import tkinter
import tkinter.font as tkFont
import urllib.request as req
import aboutme
import tkinter.messagebox as tkMessagebox
import constant
class EnvironmentHelper:
    def __init__(self):
        self.tk=tkinter.Tk()
        self.tk.title(constant.Constant().softname)
        self.sysfont=tkFont.Font(self.tk,size=16)
        
        #城市污染排行榜
        self.frmTop=tkinter.Frame(self.tk,borderwidth=10,relief=tkinter.FLAT)
        lbl=tkinter.Label(self.frmTop,text="全国空气质量最差城市实时排名",font=self.sysfont)
        lbl.grid(row=0,column=0,columnspan=4)
        
        lbl=tkinter.Label(self.frmTop,text="对比",font=self.sysfont)
        lbl.grid(row=0,column=4,padx=20)
        
        for i in range(0,10):
            lbl=tkinter.Label(self.frmTop,text="|",font=self.sysfont)
            lbl.grid(row=int(i)+1,column=4,padx=20) 
                      
        lbl=tkinter.Label(self.frmTop,text="全国空气质量最好城市实时排名",font=self.sysfont)
        lbl.grid(row=0,column=5,columnspan=4)
               
        ls=self.getWorse()
        for i in ls:
            lbl=tkinter.Label(self.frmTop,text=str(i[0]),font=self.sysfont,width=3)
            lbl.grid(row=ls.index(i)+1,column=0,ipadx=10,ipady=1)
            lbl=tkinter.Label(self.frmTop,text=str(i[1]),font=self.sysfont,width=8)
            lbl.grid(row=ls.index(i)+1,column=1,ipadx=10,ipady=1)
            lbl=tkinter.Label(self.frmTop,text=str(i[2]),font=self.sysfont,width=3)
            lbl.grid(row=ls.index(i)+1,column=2,ipadx=10,ipady=1)
            lbl=tkinter.Label(self.frmTop,text=str(i[3]),font=self.sysfont,width=5)
            lbl.grid(row=ls.index(i)+1,column=3,ipadx=10,ipady=1)
        ls=self.getBest()
        for i in ls:
            lbl=tkinter.Label(self.frmTop,text=str(i[0]),font=self.sysfont,width=3)
            lbl.grid(row=ls.index(i)+1,column=5,ipadx=10,ipady=1)
            lbl=tkinter.Label(self.frmTop,text=str(i[1]),font=self.sysfont,width=8)
            lbl.grid(row=ls.index(i)+1,column=6,ipadx=10,ipady=1)
            lbl=tkinter.Label(self.frmTop,text=str(i[2]),font=self.sysfont,width=3)
            lbl.grid(row=ls.index(i)+1,column=7,ipadx=10,ipady=1)  
            lbl=tkinter.Label(self.frmTop,text=str(i[3]),font=self.sysfont,width=5)
            lbl.grid(row=ls.index(i)+1,column=8,ipadx=10,ipady=1)   
        self.frmTop.grid(row=2,column=0)
        
        #当前城市情况
        self.frmMid=tkinter.Frame()
        lbl=tkinter.Label(self.frmMid,text="当前城市实时空气质量指数(AQI)",font=self.sysfont)
        lbl.grid(row=0,column=0,padx=50,columnspan=2)
        self.btn=tkinter.Button(self.frmMid,text="设定城市",width=5,font=self.sysfont,command=self.changeCity)
        self.btn.grid(row=0,column=2,padx=20,pady=10)
        self.btn=tkinter.Button(self.frmMid,text="关于",width=5,font=self.sysfont,command=lambda:aboutme.AboutMe(self.tk))
        self.btn.grid(row=0,column=3,padx=20,pady=10)
        lbl=tkinter.Label(self.frmMid,text="城市名称",font=self.sysfont)
        lbl.grid(row=1,column=0,padx=10)
        lbl=tkinter.Label(self.frmMid,text="AQI(中)",font=self.sysfont)
        lbl.grid(row=2,column=0,padx=10)        
        lbl=tkinter.Label(self.frmMid,text="AQI(美)",font=self.sysfont)
        lbl.grid(row=3,column=0,padx=10)        
        self.cityname = tkinter.StringVar()
        self.cityname.set("")
        self.lblcityname=tkinter.Label(self.frmMid,textvariable=self.cityname,font=self.sysfont)
        self.lblcityname.grid(row=1,column=1)
        
        self.aqi = tkinter.StringVar()
        self.aqi.set(0)
        self.lblaqi=tkinter.Label(self.frmMid,textvariable=self.aqi,font=self.sysfont)
        self.lblaqi.grid(row=2,column=1)
        
        self.aqimei = tkinter.StringVar()
        self.aqimei.set(0)
        self.lblaqimei=tkinter.Label(self.frmMid,textvariable=self.aqimei,fg="#ff0000",font=self.sysfont)
        self.lblaqimei.grid(row=3,column=1)        
        
        
        self.frmMid.grid(row=0,column=0)
        
        self.frmBottom=tkinter.Frame(self.tk,height=30)

        self.frmBottom.grid(row=3,column=0) 
        self.frmSep=tkinter.Frame(self.tk,height=30)

        self.frmSep.grid(row=1,column=0)         
        self.getCity()
        self.getAQI()
        self.tk.mainloop()
        
        
        
    def changeCity(self):
        self.top=tkinter.Toplevel(self.tk)
        self.top.title("设定城市")
        lbl=tkinter.Label(self.top,text="请在下面的文本框中输入城市名称的拼音(如：baoding)",font=self.sysfont)
        lbl.grid(row=0,column=0,pady=10)
        self.txt=tkinter.Entry(self.top,width=30,font=self.sysfont)
        self.txt.grid(row=1,column=0,pady=10)
        btn=tkinter.Button(self.top,text="确定",width=5,font=self.sysfont,command=self.submitcity)
        btn.grid(row=2,column=0,sticky=tkinter.E,pady=10,padx=10)
        
    def submitcity(self):
        cityname=self.txt.get().strip()
        if cityname!="":
            fp=open("city.txt","w")
            fp.writelines(cityname+"\n\n")
            fp.close()
            try:
                self.getCity()
            except:
                tkMessagebox.showinfo("错误!","请输入全国主要城市！")
                self.txt.delete(0,tkinter.END)
                self.txt.focus()
            else:
                self.getAQI()
                self.top.destroy()
        else:
            tkMessagebox.showinfo("错误!","城市名不能为空！")
        
    def getCity(self):
        fp=open("city.txt")
        ct=fp.readlines()[0][:-1]
        fp.close()
        htmlstr=req.urlopen("http://www.pm2d5.com/city/"+str(ct)+".html").read().decode('utf-8')
        cityname=htmlstr.index("cityname")
        htmlstr=htmlstr[cityname+12:]
        citynameend=htmlstr.index(";")
        cityname=htmlstr[:citynameend-1]
        self.cityname.set(cityname)
        
    def getAQI(self):
        fp=open("city.txt")
        ct=fp.readlines()[0][:-1]
        fp.close()
        htmlstr=req.urlopen("http://www.pm2d5.com/city/"+str(ct)+".html").read().decode('utf-8')

        cutindex=htmlstr.index("(lb ==")

        htmlstr=htmlstr[cutindex:]
        start=htmlstr.index("jin_value")
        htmlstr=htmlstr[start+13:]
        end=htmlstr.index(';');
        aqilocal=htmlstr[:end-1]
        start=htmlstr.index("jin_value")
        htmlstr=htmlstr[start+13:]
        end=htmlstr.index(';');
        aqimei1=htmlstr[:end-1]
        self.aqi.set(aqilocal)
        self.aqimei.set(aqimei1)      
        
        
    def getWorse(self):
        htmlstr=req.urlopen("http://www.pm2d5.com/").read().decode('utf-8')
        start=htmlstr.index("全国空气质量最差城市实时排名")
        end=htmlstr.index("全国空气质量最好城市实时排名")
        #得到最差城市排名
        htmlstr=htmlstr[start:end]
        returnls=[]
        for i in range(0,10):
            if """<div class="item-hd">""" in htmlstr:
                start=htmlstr.index("""<div class="item-hd">""")
                #得到排名
                paiming=int(i)+1
                #城市名
                htmltemp=htmlstr[start:]
                citystart=htmltemp.index("</span>")
                htmltemp=htmltemp[citystart+7:]
                citystart=htmltemp.index(">")
                htmltemp=htmltemp[citystart+1:]
                citystart=0#确定城市名开端
                cityend=htmltemp.index("</a>")#确定城市名结尾
                #得到cityname
                cityname=htmltemp[citystart:cityend][:]
                htmltemp=htmltemp[cityend+4:]
                #空气污染指数
                #print(htmltemp)
                indexstart=htmltemp.index(">")
                indexend=htmltemp.index("</a>")
                #得到indexvalue
                indexvalue=htmltemp[indexstart+1:indexend][:]
                htmltemp=htmltemp[indexend+4:]
                #print(htmltemp)
                #污染级别
                rankstart=htmltemp.index(">")
                rankend=htmltemp.index("</span>")
                #得到rankvalue
                rankvalue=htmltemp[rankstart+1:rankend][:]
                htmltemp=htmltemp[indexend+3:]
                
                htmlstr=htmltemp

                #循环修改start
                returnls.append((paiming,cityname,indexvalue,rankvalue))
            
        return returnls

            
    def getBest(self):
        htmlstr=req.urlopen("http://www.pm2d5.com/").read().decode('utf-8')
        start=htmlstr.index("全国空气质量最好城市实时排名")
        end=-1
        #得到最好城市排名
        htmlstr=htmlstr[start:end]
        returnls=[]
        for i in range(0,10):
            if """<div class="item-hd">""" in htmlstr:
                start=htmlstr.index("""<div class="item-hd">""")
                #得到排名
                paiming=int(i)+1
                #城市名
                htmltemp=htmlstr[start:]
                citystart=htmltemp.index("</span>")
                htmltemp=htmltemp[citystart+7:]
                citystart=htmltemp.index(">")
                htmltemp=htmltemp[citystart+1:]
                citystart=0#确定城市名开端
                cityend=htmltemp.index("</a>")#确定城市名结尾
                #得到cityname
                cityname=htmltemp[citystart:cityend][:]
                htmltemp=htmltemp[cityend+4:]
                #空气污染指数
                #print(htmltemp)
                indexstart=htmltemp.index(">")
                indexend=htmltemp.index("</a>")
                #得到indexvalue
                indexvalue=htmltemp[indexstart+1:indexend][:]
                htmltemp=htmltemp[indexend+4:]
                #print(htmltemp)
                #污染级别
                rankstart=htmltemp.index(">")
                rankend=htmltemp.index("</span>")
                #得到rankvalue
                rankvalue=htmltemp[rankstart+1:rankend][:]
                htmltemp=htmltemp[indexend+3:]
                
                htmlstr=htmltemp

                #循环修改start
                returnls.append((paiming,cityname,indexvalue,rankvalue))
            
        return returnls
    
    
environ=EnvironmentHelper()
